Codeforces Round #538 (Div. 2) D. Flood Fill 【区间dp || LPS (最长回文序列)】

任意门:http://codeforces.com/contest/1114/problem/D

D. Flood Fill

time limit per test

2 seconds

memory limit per test

256 megabytes

input

standard input

output

standard output

You are given a line of nn colored squares in a row, numbered from 11 to nn from left to right. The ii-th square initially has the color cici.

Let‘s say, that two squares ii and jj belong to the same connected component if ci=cjci=cj, and ci=ckci=ck for all kk satisfying i<k<ji<k<j. In other words, all squares on the segment from ii to jj should have the same color.

For example, the line [3,3,3][3,3,3] has 11 connected component, while the line [5,2,4,4][5,2,4,4] has 33 connected components.

The game "flood fill" is played on the given line as follows:

  • At the start of the game you pick any starting square (this is not counted as a turn).
  • Then, in each game turn, change the color of the connected component containing the starting square to any other color.

Find the minimum number of turns needed for the entire line to be changed into a single color.

Input

The first line contains a single integer nn (1≤n≤50001≤n≤5000) — the number of squares.

The second line contains integers c1,c2,…,cnc1,c2,…,cn (1≤ci≤50001≤ci≤5000) — the initial colors of the squares.

Output

Print a single integer — the minimum number of the turns needed.

Examples

input

Copy

4
5 2 2 1

output

Copy

2

input

Copy

8
4 5 2 2 1 3 5 5

output

Copy

4

input

Copy

1
4

output

Copy

0

Note

In the first example, a possible way to achieve an optimal answer is to pick square with index 22 as the starting square and then play as follows:

  • [5,2,2,1][5,2,2,1]
  • [5,5,5,1][5,5,5,1]
  • [1,1,1,1][1,1,1,1]

In the second example, a possible way to achieve an optimal answer is to pick square with index 55 as the starting square and then perform recoloring into colors 2,3,5,42,3,5,4 in that order.

In the third example, the line already consists of one color only.

题意概括:

给一个序列不同数字代表不同颜色,相同颜色为一连通块,每次操作可以把起点所在的连通块的颜色全部置为任一种颜色。

求将色块的颜色变成全部一样的最少操作次数。

解题思路:

因为颜色相同可以看作一个连通块,所以预处理我们可以先压缩序列。

一、区间DP:

状态:dp[ L ][ R ][ 0 ] 表示将 [ L, R ] 区间的颜色变成 Color[ L ] 所需的最少次数

   dp[ L ][ R ][ 1 ] 表示将 [ L, R ] 区间的颜色变成 Color[ R ] 所需的最少次数

转移方程:

      IF:  Color[ L + 1] == Color [ L ]  dp[ L ][ R ][ 0 ] = min( dp[ L ][ R ][ 0 ], dp[ L + 1 ][ R ][ 0 ] );

      IF:  Color[ L + 1]  != Color [ L ]  dp[ L ][ R ][ 0 ] = min( dp[ L ][ R ][ 0 ], dp[ L + 1 ][ R ][ 0 ] + 1);

   IF:  Color[ R -1]  == Color [ R ]  dp[ L ][ R ][ 1 ] = min( dp[ L ][ R ][ 1 ], dp[ L ][ R - 1 ][ 1 ] );

   IF:  Color[ R -1]  != Color [ R ]  dp[ L ][ R ][ 1 ] = min( dp[ L ][ R ][ 1 ], dp[ L ][ R - 1 ][ 1 ] + 1);

AC code( 218 ms):

 1 /// 区间dp
 2 #include<cstdio>
 3 #include<algorithm>
 4 #include<iostream>
 5 #include<cstring>
 6 #include<vector>
 7 #include<queue>
 8 #include<cmath>
 9 #include<set>
10 #define INF 0x3f3f3f3f
11 #define LL long long
12 using namespace std;
13 const int MAXN = 5e3+10;
14 int dp[MAXN][MAXN][2];
15 int num[MAXN];
16 bool vis[MAXN];
17
18 int main()
19 {
20     int N = 0, x = -1, cnt = 0;
21     scanf("%d", &cnt);
22     for(int i = 1; i <= cnt; i++){
23         scanf("%d", &x);
24         if(x != num[N]) num[++N] = x;
25     }
26
27     for(int i = 1; i <= N; i++)
28         for(int j = 1; j <= N; j++)
29             dp[i][j][0] = dp[i][j][1] = (i == j?0:INF);
30
31     for(int r = 1; r <= N; r++)
32     for(int l = r; l > 0; l--)
33     for(int it = 0; it < 2; it++){
34         int c = (it==0?num[l]:num[r]);
35         if(l > 1) dp[l-1][r][0] = min(dp[l-1][r][0], dp[l][r][it]+int(c != num[l-1]));
36         if(r < N) dp[l][r+1][1] = min(dp[l][r+1][1], dp[l][r][it]+int(c != num[r+1]));
37     }
38
39     printf("%d\n", min(dp[1][N][0], dp[1][N][1]));
40
41     return 0;
42 }

二、LPS (最长回文序列长度)

试想一下,我们需要变换的点其实是那一些 不在最长回文子序列里的点。

例如: 4 1 3 7 6 3 1 5

   最长回文子序列是 1 3 3 1,为了结果最优,我们肯定优先从 7 6 入手,而回文子序列只需要操作一半即可(因为对称),剩下就是处理 4 5。

那么问题就转换为了求LPS:

两种求法:

①直接dp:

AC code(109 ms):

 1 /// LCS
 2 #include<cstdio>
 3 #include<algorithm>
 4 #include<iostream>
 5 #include<cstring>
 6 #include<vector>
 7 #include<queue>
 8 #include<cmath>
 9 #include<set>
10 #define INF 0x3f3f3f3f
11 #define LL long long
12 using namespace std;
13 const int MAXN = 5e3+10;
14 int num[MAXN];
15 int dp[MAXN][MAXN];
16
17 int main()
18 {
19     int N = 0, cnt, x;
20     scanf("%d", &cnt);
21     for(int i = 1; i <= cnt; i++){
22         scanf("%d", &x);
23         if(x != num[N]) num[++N] = x;
24     }
25     for(int i = 0; i <= N; i++) dp[i][i] = 1;
26
27     for(int i = 1; i < N; i++)
28     for(int j = 1; j+i <= N; j++){
29         if(num[j] == num[j+i]) dp[j][j+i] = dp[j+1][j+i-1] + 2;
30         else dp[j][i+j] = max(dp[j+1][j+i], dp[j][j+i-1]);
31     }
32
33     int ans = N-(dp[1][N]+1)/2;
34     printf("%d\n", ans);
35
36     return 0;
37
38 }

②反向复制原序列,通过原序列求 LCS (最长公共序列)

AC code(78 ms):

/// LCS
#include<cstdio>
#include<algorithm>
#include<iostream>
#include<cstring>
#include<vector>
#include<queue>
#include<cmath>
#include<set>
#define INF 0x3f3f3f3f
#define LL long long
using namespace std;
const int MAXN = 5e3+10;
int num[MAXN], b[MAXN];
int dp[MAXN][MAXN];

int main()
{
    int N = 0, cnt, x;
    scanf("%d", &cnt);
    for(int i = 1; i <= cnt; i++){
        scanf("%d", &x);
        if(x != num[N]) num[++N] = x;
    }
    int E = N;
    for(int i = 1; i <= N; i++){
            b[E--] = num[i];
    }

    for(int i = 1; i <= N; i++)
    for(int j = 1; j <= N; j++){
        if(num[i] == b[j]) dp[i][j] = dp[i-1][j-1]+1;
        else dp[i][j] = max(dp[i-1][j], dp[i][j-1]);
    }
    int ans = N-(dp[N][N]+1)/2;

    printf("%d\n", ans);

    return 0;

}

原文地址:https://www.cnblogs.com/ymzjj/p/10372082.html

时间: 2024-10-08 12:51:33

Codeforces Round #538 (Div. 2) D. Flood Fill 【区间dp || LPS (最长回文序列)】的相关文章

Codeforces Round #336 (Div. 2) D. Zuma(区间DP)

题目链接:https://codeforces.com/contest/608/problem/D 题意:给出n个宝石的颜色ci,现在有一个操作,就是子串的颜色是回文串的区间可以通过一次操作消去,问最少需要多少次操作可以消除所有的宝石.(每次操作消除一个回文串,最少操作次数清楚字符串) 题解:dp[l][r]表示区间(l,r)的最少操作次数,对于一个区间(l,r),有两种转移:①若存在c_l = c_i(l <= i <= r),可以由dp[l][i] + dp[i + 1][r]转移:②若c

Codeforces Round #106 (Div. 2) Coloring Brackets(区间DP)

题意:给你一组括号序列,让你进行染色,对于每个括号,有无色,红色,蓝色三种方案.染色需要满足这样的条件:互相匹配的括号,有且只有一个有颜色,相邻的括号不能颜色相同(可以同为无色),问合法的染色方案数(答案%1e9+7) 分析:根据题意能够看出是区间DP,并且状态转移的时候,依赖于左右两端的颜色,所以我们用dp[i][j][x][y]表示i到j的区间内左端颜色为x,右端颜色为y的方案数. 区间[i,j]可以由两种情况得到,一种是str[i],str[j]匹配,产生新的相匹配的括号,考虑在只有一端染

Codeforcs 1114D Flood Fill (区间DP or 最长公共子序列)

题意:给你n个颜色块,颜色相同并且相邻的颜色块是互相连通的(连通块).你可以改变其中的某个颜色块的颜色,不过每次改变会把它所在的连通块的颜色也改变,问最少需要多少次操作,使得n个颜色块的颜色相同. 例如:[1, 2, 2, 3, 2]需要2步:[1, 2, 2, 3, 2] -> [1, 2, 2, 2, 2] -> [2, 2, 2, 2, 2]. 思路:我们先把颜色块压缩(即把本来颜色相同并且相邻的颜色块合并).容易发现,如果出现了形如[1, 2, 3, 1]这种情况, 那么显然先合并两个

Codeforces Round #538 (Div. 2) (CF1114)

Codeforces Round #538 (Div. 2) (CF1114) ??今天昨天晚上的cf打的非常惨(仅代表淮中最低水平 ??先是一路缓慢地才A掉B,C,然后就开始杠D.于是写出了一个O(n^2)的线性dp,然后就wa6,调到结束.结束后发现完全看漏了两句话.噢,起始点!!! ??好吧然后算算自己有可能这一场要变成+0,反正在0左右. 结束后开始然后开始写D,顺便思考F.结果写完D发现A怎么fst了,然后...因为习惯于对相似的语句复制粘贴,有些东西没有改--三句话都在 -a!!!(

Codeforces Round #538 (Div. 2)

目录 Codeforces 1114 A.Got Any Grapes? B.Yet Another Array Partitioning Task C.Trailing Loves (or L'oeufs?) D.Flood Fill(区间DP) E.Arithmetic Progression(交互 二分 随机化) F.Please, another Queries on Array?(线段树 欧拉函数) Codeforces 1114 比赛链接 貌似最近平均难度最低的一场div2了...

Codeforces Round #417 (Div. 2) B. Sagheer, the Hausmeister(DP)

题目链接:Codeforces Round #417 (Div. 2) B. Sagheer, the Hausmeister 题意: 有n层楼,每层有m个房间,每层的两边是楼梯. 现在有一个人站在左下角,这个人必须将这一层的灯关闭后才能去另外一层. 每移动一次需要1分钟,问关闭所有灯需要多少时间. 题解: 考虑DP[i][j]表示当前已经关闭了第i层全部的灯,j=0时表示在这一层的最左边,j=1时表示在这一层的最右边. 然后推上去就行了.最后讨论一下特殊情况. 1 #include<bits/

Codeforces Round #360 (Div. 2) D 数学推导 E dp

Codeforces Round #360 (Div. 2) A  == B  水,但记一下: 第 n 个长度为偶数的回文数是  n+reverse(n). C    dfs 01染色,水 #include<bits/stdc++.h> using namespace std; #pragma comment(linker, "/STACK:102400000,102400000") #define rep(i,a,b) for (int i=a; i<=b; ++i

Codeforces Round #538 (Div. 2) E 随机数生成

https://codeforces.com/contest/1114/problem/E 题意 交互题,需要去猜一个乱序的等差数列的首项和公差,你能问两种问题 1. 数列中有没有数比x大 2. 数列的第i项是什么 最多只能问60次 题解 首先用第一种问题+二分问出数列最大的数是多少,最多二十次 然后用第二种问题尽可能分散的询问第i项,然后将问出的数组排序,对相邻两个数的差求gcd 随机数生成链接 https://codeforces.com/blog/entry/61587 https://c

[codeforces]Round #538 (Div. 2) F. Please, another Queries on Array?

题解:    $$  ans=F\left ( \prod _{i=l}^{r}a_i \right ) $$ $$ =(p_i-1){p_i}^{k_i-1}*.....*(p_j-1){p_j}^{k_j-1} $$ $$={p_i}^{k_i}*.....*{p_j}^{k_j}*(\frac{p_i-1}{p_i}*......*\frac{p_j-1}{p_j})  $$ 因为数据范围保证$ a_i\leq 300 $ 所以在这个范围内只有62个素因子  我们可以直接每一位对应一bit